#include "cpjit.h"

#include <iostream>

using namespace cpjit;
using namespace std;

int main (void)
{
  env e ("/tmp/libcpjit");

  funbuild2<U32, U32 *, U64> fb (e);
  fb << "return a1[0] + a2;";

  fun *f = fb.get ();

  U32 i = 3;
  cout << f->call<U32, PTR, U64> (&i, 2) << endl;

  return 0;
}
